# RatingBuster

## [1.9.0](https://github.com/raethkcj/RatingBuster/tree/1.9.0) (2023-07-27)
[Full Changelog](https://github.com/raethkcj/RatingBuster/compare/1.8.0...1.9.0) [Previous Releases](https://github.com/raethkcj/RatingBuster/releases)

- Account for weapon skill in crit conversion  
- Add weapon stat mod validator  
- Remove reference to ItemLevel addon  
- Restrict GetTotalEquippedStat to Vanilla  
- Add Rallying Cry  
- Add spell crit modifier  
- Rename addonTable for brevity  
- Remove erroneous PI modifiers  
- Add MOD\_ARMOR BuffGroup  
- Add melee crit modifiers  
- Add GetSpellCritPerInt with fallback calculation  
- Remove debug statement  
- Add CritPerAgi with fallback calculation  
    diff --git a/libs/StatLogic/StatLogic.lua b/libs/StatLogic/StatLogic.lua  
    index f7fc204..7490c59 100644  
    --- a/libs/StatLogic/StatLogic.lua  
    +++ b/libs/StatLogic/StatLogic.lua  
    @@ -818,6 +818,10 @@ StatLogic.StatModInfo = {  
     		finalAdjust = 0,  
     		school = true,  
     	},  
    +	["ADD\_MELEE\_CRIT"] = {  
    +		initialValue = 0,  
    +		finalAdjust = 0,  
    +	},  
     	["ADD\_DODGE"] = {  
     		initialValue = 0,  
     		finalAdjust = 0,  
    @@ -2004,6 +2008,28 @@ end  
     }  
     -----------------------------------]]  
    +function StatLogic:GetCritPerAgi(class, level)  
    +	-- argCheck for invalid input  
    +	self:argCheck(class, 3, "nil", "string", "number")  
    +	self:argCheck(level, 4, "nil", "number")  
    +	class = self:ValidateClass(class)  
    +	-- if level is invalid input, default to player level  
    +	if type(level) ~= "number" or level < 1 or level > GetMaxPlayerLevel() then  
    +		level = UnitLevel("player")  
    +	end  
    +  
    +	if addonTable.CritPerAgi[class][level] then  
    +		return addonTable.CritPerAgi[class][level]  
    +	else  
    +		local _, agility = UnitStat("player", 2)  
    +		local critFromAgi = GetCritChance()  
    +			- self:GetStatMod("ADD\_MELEE\_CRIT")  
    +			- self:GetTotalEquippedStat(StatLogic.Stats.MeleeCrit)  
    +		print(critFromAgi)  
    +		return (critFromAgi - addonTable.BaseMeleeCrit[class]) / agility  
    +	end  
    +end  
    +  
     function StatLogic:GetCritFromAgi(agi, class, level)  
     	-- argCheck for invalid input  
     	self:argCheck(agi, 2, "number")  
    @@ -2015,7 +2041,7 @@ function StatLogic:GetCritFromAgi(agi, class, level)  
     		level = UnitLevel("player")  
     	end  
     	-- Calculate  
    -	return agi * addonTable.CritPerAgi[class][level], StatLogic.Stats.MeleeCrit  
    +	return agi * self:GetCritPerAgi(class, level), StatLogic.Stats.MeleeCrit  
     end  
- Replace crit strings with stats  
- Remove debug statement  
- Use real sum instead of private cache  
- Remove debug statement  
- Improve Vanilla DodgePerAgi estimation  
- Fix whitespace  
- Improve DodgePerAgi for Vanilla  
- Update Vanilla BaseDodge  
- Don't truncate expertise in Wrath  
- Bump tocs  
